'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Public Class Form1

#Region "Initialization"
    Public Sub New()
        InitializeComponent()

        Me.listBox1.NormalItemStyle.BorderColor = Color.LightGray
        Me.listBox1.ScrollStep = LidorSystems.IntegralUI.Lists.ScrollStep.Pixel

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r""><p>   This sample shows how to increase space between items and how to use margin and padding to change the distance between item and control border and also between item border and its content.</p><br></br>"
        content += "<p>   To change the distance between items we are using the <b>ItemSpacing</b> property. Any value between 0 and 255 is allowed.</p><br></br>"
        content += "<p>   To change the distance between item border and control border we are using the <b>Margin</b> property which allows to set a different value for each item side.</p><br></br>"
        content += "<p>   Similarly to change the distance between item border and its content elements we are using the <b>Padding</b> property which allows to set a different value for each item side.</p><br></br>"
        content += "<p>   From control panel you can change the values for these properties and see their effect. If you want to set spacing for individual item, first select it, uncheck the Style From Parent and than change its margin or padding values. To switch back to settings for all items, click on Reset button</p><br></br>"
        content += "<p><table width=""100%"" cellpadding=""5""><tr><td width=""100%"" style=""align:middleright;textcolor:DarkRed;hovertextcolor:Red""><a href=""www.lidorsystems.com/support/articles/winforms/listbox/"">More Info ...</a></td></tr></table></p>"
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub labelInfo_ContentObjectClicked(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectClickEventArgs) Handles labelInfo.ContentObjectClicked
        If TypeOf e.[Object] Is LinkLabel Then
            System.Diagnostics.Process.Start(TryCast(e.[Object], LinkLabel).Links(0).LinkData.ToString())
        End If
    End Sub

    Private Sub InitList()
        Me.listBox1.SuspendUpdate()

        Dim item As LidorSystems.IntegralUI.Lists.ListBoxItem = Nothing
        For i As Integer = 1 To 100
            item = New LidorSystems.IntegralUI.Lists.ListBoxItem("Item " & i.ToString())

            Me.listBox1.Items.Add(item)
        Next

        Me.listBox1.ResumeUpdate()
    End Sub
#End Region

#Region "Item Spacing"
    Private Sub numSpacing_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles numSpacing.ValueChanged
        Me.listBox1.ItemSpacing = CInt(numSpacing.Value)
    End Sub

    Private Sub btnSeparator_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSeparator.Click
        Dim cDlg As New ColorDialog()
        If cDlg.ShowDialog() = DialogResult.OK Then
            Me.listBox1.ColorStyle.ItemSeparatorColor = cDlg.Color
        End If
    End Sub
#End Region

#Region "Margin and Padding"
    Private Sub listBox1_AfterSelect(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectEventArgs) Handles listBox1.AfterSelect
        If TypeOf e.[Object] Is LidorSystems.IntegralUI.Lists.ListBoxItem Then
            Dim item As LidorSystems.IntegralUI.Lists.ListBoxItem = DirectCast(e.[Object], LidorSystems.IntegralUI.Lists.ListBoxItem)

            selItemLabel.Text = item.Text
            styleFromParent.Enabled = True
            styleFromParent.Checked = item.StyleFromParent

            rbMargin.Checked = True

            If item.StyleFromParent Then
                numLeft.Value = Me.listBox1.ItemFormatStyle.Margin.Left
                numTop.Value = Me.listBox1.ItemFormatStyle.Margin.Top
                numRight.Value = Me.listBox1.ItemFormatStyle.Margin.Right
                numBottom.Value = Me.listBox1.ItemFormatStyle.Margin.Bottom
            Else
                numLeft.Value = item.FormatStyle.Margin.Left
                numTop.Value = item.FormatStyle.Margin.Top
                numRight.Value = item.FormatStyle.Margin.Right
                numBottom.Value = item.FormatStyle.Margin.Bottom
            End If
        End If
    End Sub

    Private Sub btnReset_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnReset.Click
        selItemLabel.Text = [String].Empty
        Me.listBox1.SelectedItem = Nothing
        styleFromParent.Enabled = False

        UpdateMarginPaddingValues()
    End Sub

    Private Sub styleFromParent_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles styleFromParent.CheckedChanged
        If Me.listBox1.SelectedItem IsNot Nothing Then
            Me.listBox1.SelectedItem.StyleFromParent = styleFromParent.Checked
            Me.listBox1.SelectedItem.NormalStyle.BorderColor = Color.LightGray

            UpdateMarginPaddingValues()
        End If
    End Sub

    Private Sub btnApply_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnApply.Click
        ' Apply changes to Margin and Padding for a specific item (selected one in this case)
        If Not styleFromParent.Checked AndAlso Me.listBox1.SelectedItem IsNot Nothing Then
            If rbMargin.Checked Then
                Me.listBox1.SelectedItem.FormatStyle.Margin = New Padding(CInt(numLeft.Value), CInt(numTop.Value), CInt(numRight.Value), CInt(numBottom.Value))
            Else
                Me.listBox1.SelectedItem.FormatStyle.Padding = New Padding(CInt(numLeft.Value), CInt(numTop.Value), CInt(numRight.Value), CInt(numBottom.Value))
            End If

            Me.listBox1.UpdateCurrentView()
        Else
            ' Apply changes to Margin and Padding for all items
            If rbMargin.Checked Then
                Me.listBox1.ItemFormatStyle.Margin = New Padding(CInt(numLeft.Value), CInt(numTop.Value), CInt(numRight.Value), CInt(numBottom.Value))
            Else
                Me.listBox1.ItemFormatStyle.Padding = New Padding(CInt(numLeft.Value), CInt(numTop.Value), CInt(numRight.Value), CInt(numBottom.Value))
            End If
        End If
    End Sub

    Private Sub MarginPadding_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles rbMargin.CheckedChanged, rbPadding.CheckedChanged
        UpdateMarginPaddingValues()
    End Sub

    Private Sub UpdateMarginPaddingValues()
        Dim item As LidorSystems.IntegralUI.Lists.ListBoxItem = Me.listBox1.SelectedItem

        If rbMargin.Checked Then
            If item IsNot Nothing AndAlso Not item.StyleFromParent Then
                numLeft.Value = item.FormatStyle.Margin.Left
                numTop.Value = item.FormatStyle.Margin.Top
                numRight.Value = item.FormatStyle.Margin.Right
                numBottom.Value = item.FormatStyle.Margin.Bottom
            Else
                numLeft.Value = Me.listBox1.ItemFormatStyle.Margin.Left
                numTop.Value = Me.listBox1.ItemFormatStyle.Margin.Top
                numRight.Value = Me.listBox1.ItemFormatStyle.Margin.Right
                numBottom.Value = Me.listBox1.ItemFormatStyle.Margin.Bottom
            End If
        Else
            If item IsNot Nothing AndAlso Not item.StyleFromParent Then
                numLeft.Value = item.FormatStyle.Padding.Left
                numTop.Value = item.FormatStyle.Padding.Top
                numRight.Value = item.FormatStyle.Padding.Right
                numBottom.Value = item.FormatStyle.Padding.Bottom
            Else
                numLeft.Value = Me.listBox1.ItemFormatStyle.Padding.Left
                numTop.Value = Me.listBox1.ItemFormatStyle.Padding.Top
                numRight.Value = Me.listBox1.ItemFormatStyle.Padding.Right
                numBottom.Value = Me.listBox1.ItemFormatStyle.Padding.Bottom
            End If
        End If
    End Sub
#End Region

End Class
